from xblock.core import XBlock


class SelfAssessmentMixin(object):
    """The Self Assessment Mixin for all Self Assessment Functionality.

    Abstracts all functionality and handlers associated with Self Assessment.
    All Self Assessment API calls should be contained without this Mixin as
    well.

    SelfAssessmentMixin is a Mixin for the OpenAssessmentBlock. Functions in
    the SelfAssessmentMixin call into the OpenAssessmentBlock functions and
    will not work outside of OpenAssessmentBlock.

    """

    @XBlock.handler
    def render_self_assessment(self, data, suffix=''):
        return self.render_assessment('openassessmentblock/self/oa_self_assessment.html')

